# SPDX-FileCopyrightText: <text>Copyright 2023 Arm Limited and/or its
# affiliates <open-source-office@arm.com></text>
#
# SPDX-License-Identifier: MIT
---
device_type: fvp
job_name: {{ CI_JOB_NAME }}

timeouts:
  connection:
    minutes: 3
  job:
    minutes: 260
  actions:
    fvp-deploy:
      minutes: 20
    download-retry:
      minutes: 20
    http-download:
      minutes: 20

metadata:
  source: {{ CI_PROJECT_URL }}
  path: gitlab-ci/templates/lava/corstone1000-fvp/java-tester_job.yml.j2
  gitlab-job-url: {{ CI_JOB_URL }}

priority: medium
visibility:
  group:
    - cassini

context:
  boot_character_delay: 250
  test_character_delay: 250

notify:
  criteria:
    status: finished
  callbacks:
    - url: "{{ CI_API_V4_URL }}/projects/{{ CI_PROJECT_ID }}/jobs/{{ TEST_COMPLETE_JOB_ID }}/play"
      method: POST
      token: "{{ LAVA_CALLBACK_TOKEN }}"
      header: "PRIVATE-TOKEN"
      dataset: minimal

actions:
- deploy:
    to: downloads
    timeout:
      minutes: 20
    images:
      mmc0:
        url: {{ IMAGE_ARTIFACT }}
        compression: xz
      jfrog:
        url: "https://releases.jfrog.io/artifactory/jfrog-cli/v2/[RELEASE]/jfrog-cli-linux-arm64/jfrog"
    postprocess:
      docker:
        image: {{ CI_REGISTRY }}/{{ CI_PROJECT_PATH }}/utility-image:{{ DOCKER_IMAGE_TAG }}
        steps:
          - gdisk -l {{ IR_IMG }}
          - |
            guestfish --rw -a {{ IR_IMG }} << EOF
            launch
            list-filesystems
            mount /dev/sda1 /
            copy-out /EFI/BOOT/bbr/SCT/Sequence/EBBR.seq .
            umount /
            EOF
          - splitter.py --splits {{ TOTAL_SEQUENCE_FILES }} EBBR.seq {{ SEQUENCE_FILE_PREFIX }}
          - mv {{ SEQUENCE_FILE_PREFIX }}_{{ SEQUENCE_FILE_NUMBER }}.seq EBBR.seq
          - |
            cat << EOF > init.sh
            #!/bin/sh
            echo "init.sh"
            echo "ACS run is completed"
            echo "Please press <Enter> to continue ..."
            echo -e -n "\n"
            exit 0
            EOF
          - |
            guestfish --rw -a {{ IR_IMG }} << EOF
            launch
            mount /dev/sda1 /
            copy-in EBBR.seq /EFI/BOOT/bbr/SCT/Sequence/
            umount /
            mount /dev/sda2 /
            copy-in jfrog /bin/
            acl-set-file /bin/jfrog access u::rwx,g::rx,o::rx
{%- if SEQUENCE_FILE_NUMBER != "1" %}
            copy-in init.sh /usr/bin/
            acl-set-file /usr/bin/init.sh access u::rwx,g::rx,o::rx
{%- endif %}
            umount /
            EOF
          - dd if=/dev/zero count=1024 bs=512 >> {{ IR_IMG }}

- deploy:
    to: fvp
    images:
      bl1:
        url: {{ BL1_ARTIFACT }}
      cs1000:
        url: {{ FIRMWARE_ARTIFACT }}
      extsys:
        url: {{ EXTSYS_ARTIFACT }}

- boot:
    method: fvp
    docker:
      name: "{{ CI_REGISTRY }}/{{ CI_PROJECT_PATH }}/cs1k-fvp-test-image:{{ DOCKER_IMAGE_TAG }}"
    image: /opt/models/Linux64_GCC-9.3/FVP_Corstone-1000
    version_string: 'Fast Models [^\\n]+'
    timeout:
      minutes: 210
    console_string: 'host_terminal_0: Listening for serial connection on port (?P<PORT>\d+)'
    feedbacks:
      - '(?P<NAME>host_terminal_1): Listening for serial connection on port (?P<PORT>\d+)'
      - '(?P<NAME>secenc_terminal): Listening for serial connection on port (?P<PORT>\d+)'
      - '(?P<NAME>extsys_terminal): Listening for serial connection on port (?P<PORT>\d+)'
    arguments:
      - "-C se.trustedBootROMloader.fname={BL1}"
      - "-C board.msd_mmc.p_mmc_file={MMC0}"
      - "-C extsys_harness0.extsys_flashloader.fname={EXTSYS}"
      - "-C extsys0.extsys_terminal.start_telnet=1"
      - "-C host.host_terminal_0.start_telnet=1"
      - "-C host.host_terminal_1.start_telnet=1"
      - "-C se.secenc_terminal.start_telnet=1"
      - "--data board.flash0={CS1000}@0x68100000"
    parameters:
      kernel-start-message: 'EFI stub: Booting Linux Kernel...'
    prompts:
      - 'root@generic-arm64:~# '
    transfer_overlay:
      download_command: wget -S
      unpack_command: tar -C / -xzf


- test:
    timeout:
      minutes: 40
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: upload-acs-reports
            description: '"Upload ACS reports"'
            os:
              - debian
            scope:
              - functional
          run:
            steps:
              - while [ $(systemctl show -p SubState --value acs_run-before-login-prompt) != "exited" ]; do echo "Waiting for tests to finish"; sleep 60; done
              - echo "{{ ARTIFACTORY_HOST_IP }} {{ ARTIFACTORY_HOST_NAME }}" >> /etc/hosts
              - echo "{{ NTP_HOST_NAME }} {{ NTP_HOST_IP }}" >> /etc/hosts
              - jfrog config add artifactory-aws --interactive=false --artifactory-url={{ ARTIFACTORY_AWS_URL }} --user={{ ARTIFACTORY_USER }} --password={{ ARTIFACTORY_PASS }}
              - if [ -d /mnt/acs_results ]; then cp -a /mnt/acs_results/* /results/; fi
              - cd /results
              - ls -laR acs_results
              - |
                cat << EOF > ./upload_spec.json
                {
                  "files": [
                    {
                      "pattern": "acs_results/",
                      "target": "oss-cassini.lava-images-temp/",
                      "flat": "false",
                      "recursive": "true"
                    }
                  ]
                }
                EOF
              - build_name="oss-cassini/{{ CI_PROJECT_PATH }}/{{ CI_JOB_NAME }}"
              - jfrog rt upload --spec=upload_spec.json --build-name="${build_name}" --build-number="{{ CI_JOB_ID }}"
              # Collect environment variables and attach them to a build.
              - jfrog rt build-collect-env "${build_name}" "{{ CI_JOB_ID }}"
              # Publish build info to Artifactory
              - jfrog rt build-publish "${build_name}" "{{ CI_JOB_ID }}"  --build-url="{{ CI_PROJECT_URL }}"
              # Discard builds and artifacts previously published to Artifactory
              - jfrog rt build-discard "${build_name}" --max-builds=20 --delete-artifacts --async
        from: inline
        name: upload-acs-reports
        path: inline/upload-acs-reports.yaml

- test:
    timeout:
      minutes: 2
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: dump_upload_log
            description: '"Output Upload log"'
            os:
              - debian
            scope:
              - functional
          run:
            steps:
            - cat /home/root/.jfrog/logs/jfrog-cli.*.log || true
        from: inline
        name: output-upload-log
        path: inline/output-upload-log.yaml
